#!/bin/bash

end()
{
	echo "shutting down"
	kill -s SIGINT $PID
	wait $PID
	echo "terminated, ${restarts} total restarts"
}

#https://stackoverflow.com/a/67498490/5475891
#INTR=0
#function setINTR()
#{
#	INTR=1
#}
#
#trap -- 'setINTR' SIGINT

maxMem=$((6 * 1024 * 1024))
#echo "maxMem ${maxMem}"
restarts=0
bash start.sh &
PID=$!
echo "PID ${PID}"

trap end EXIT #SIGINT

while [[ true ]] #[ INTR -eq 0 ]
do
	while ! test -d /proc/${PID}/
	do
		echo "Process missing, starting again $((restarts++))"
		bash start.sh &
		PID=$!
		sleep 10
	done
	sleep 60
	memory=$(cat /proc/${PID}/status | grep "VmPeak" | xargs | cut -d " " -f 2)
	#echo "memory ${memory}"
	if [[ $memory -gt $maxMem ]]
	then
		echo "Memory ${memory}/${maxMem}! Restarting $((restarts++))"
		kill -s SIGINT $PID
		echo "Interrupt sent: $(date)"
		wait $PID
		echo "Stopped"
		bash start.sh &
		PID=$!
		echo "Started"
	fi
done

#while kill -0 $PID &> /dev/null
#do
#	wait $PID
#done
